#include "globals.h"

/*********************************************************************************\
This defines default values for various global data that we use as library options.
\*********************************************************************************/

float physics::Globals::inverseTimeStep = 60;

bool physics::Globals::useSleeping = true;
float physics::Globals::linearVelocitySleepEpsilon = 1.5f;
float physics::Globals::angularVelocitySleepEpsilon = 0.01f;
float physics::Globals::sleepRWABias = 0.5f;

float physics::Globals::penetrationEpsilon = 0.005f;


//air resistance parameters

bool physics::Globals::airResistance = false;
bool physics::Globals::linearDrag = true;

float physics::Globals::linearDragCoefficient = 0.01f;
float physics::Globals::quadraticDragCoefficient = 0.01f;



bool physics::Globals::useRestitution = true;
float physics::Globals::restitutionThreshold = 0.2f;

bool physics::Globals::splitImpulses = true;

bool physics::Globals::findMultipleContacts = true;

bool physics::Globals::findSleepingContacts = false;

// Doesn't work in 3D
bool physics::Globals::cacheContacts = true;

physics::Globals::WhenToMoveEnum physics::Globals::whenToMove = physics::Globals::MOVE_AFTER_COLLISIONS;

float physics::Globals::_NEAR = 0.1f;

float physics::Globals::DEFAULT_DENSITY = 1.0f;
float physics::Globals::DEFAULT_RESTITUTION = 0.4f;
float physics::Globals::DEFAULT_FRICTION = 0.5f;

float physics::Globals::GRAVITY = -9.8f;

float physics::Globals::DEFAULT_TIMESTEP = 1.0f / 60.0f;

const float physics::Globals::PI = 3.1415926535897932384626f;

// Okay, this doesn't technically belong here. But we don't need a one line vector.cpp file.

#include "vector.h"

const float physics::Vector2D::z = 0.0f;

