#ifndef _PHYSICS_HALFSPACE_
#define _PHYSICS_HALFSPACE_

#include "common.h"

#include "shape.h"
#include "contact.h"

namespace physics {
	template <typename d>
	class HalfSpace {
		public:
		
		USE_DIMENSION(d);
		
		HalfSpace (const Vector& normal = Vector(0, 1), float offset = 0)
			: normal(normal), offset(offset)
		{
			normal = normal.normalise();
		}
		
		bool contains (const Vector2D &p, float tolerance = 0) const {
			return (p.dot(normal) < -offset);
		}
		
		Contact* test (Shape* shape, float nearVal) const {
			Contact* c = 0;
			
			Vector p = shape->getExtremePoint(-normal);
		}
		
		Vector normal;
		float offset;
	};
};

#endif

