#include "microtimer.h"

#ifdef WIN32
#define WINDOWS_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>

int physics::MicroTimer::gettimeofday(struct timeval *tv, struct timezone *tz)
	{
		LARGE_INTEGER ticksPerSecond;
		LARGE_INTEGER tick;   // A point in time
		LARGE_INTEGER time;   // For converting tick into real time
		
		if (NULL != tv)
		{
			// get the high resolution counter's accuracy
			QueryPerformanceFrequency(&ticksPerSecond);
			LONGLONG ticksPerMicrosecond = ticksPerSecond.QuadPart / 1000000;
			
			// what time is it?
			QueryPerformanceCounter(&tick);
			
			time.QuadPart = tick.QuadPart/ticksPerMicrosecond;
			
			tv->tv_sec = (long)(time.QuadPart / 1000000UL);
			tv->tv_usec = (long)(time.QuadPart % 1000000UL);
		}
		
		return 0;
	}

#endif
