#include "camera.h"


Camera::Camera()
{

	// positon in the world co-ordinates
	position = Vector3D(0,50,0);
	
	// axes of the camera - to orientate the camera with respect to itself
	viewDir = Vector3D(0,0,-1.0);
	upDir = Vector3D(0,1.0,0);
	rightDir = Vector3D(1.0,0,0);
	// the values above are the standard opengl init values for a new scene
	
	
	cameraMoved = false;
	viewDirChanged = false;
	
	xRotation = yRotation = zRotation = 0;
	currentRotationAngle = 0;
	
}

Camera::~Camera()
{
}



void Camera::rotateX(float angle){
	
	xRotation += angle;
	viewDir = (viewDir * cos(angle*PIby180) + upDir* sin(angle * PIby180));
	viewDir = viewDir.normalise();  // had me going for a while with this returning a new vector and not modifying the object itself :@
	
	// FPS camera ftw - up stays up
	//upDir = rightDir.cross(viewDir);
	//upDir = upDir.normalise();
		
}

void Camera::rotateY(float angle){
	
	yRotation += angle;
	viewDir = (viewDir * cos(angle*PIby180) - rightDir* sin(angle * PIby180));
	viewDir = viewDir.normalise();
		
	rightDir = viewDir.cross(upDir);
	rightDir = rightDir.normalise();
	
}



void Camera::setCamera(Vector3D pos, Vector3D view, Vector3D up){
	
	// create the new orthonormal frame

	position = pos;

	viewDir = view - pos;
	viewDir = viewDir.normalise();
	
	upDir = up;
	upDir = upDir.normalise();

	rightDir = viewDir.cross(upDir);
	rightDir = rightDir.normalise();
	

}

void Camera::moveforwardCamera(float step){
	
	position += (viewDir*-step);
}

void Camera::strafeCamera(float step){
	
	position += (rightDir*-step);
	
}

void Camera::render(){
	
	// using gluLookAt for the time being though other implementation should be fine for us
		
	Vector3D viewPoint = position + viewDir;
			
	gluLookAt(	position.x,position.y,position.z,
				viewPoint.x,viewPoint.y,viewPoint.z,
				upDir.x,upDir.y,upDir.z);
	
	//glRotatef(-xRotation , 1.0, 0.0, 0.0);
	//glRotatef(-yRotation , 0.0, 1.0, 0.0);
	//glRotatef(-zRotation , 0.0, 0.0, 1.0);
	//glTranslatef( -position.x, -position.y, -position.z );

}

void Camera::testMouse(int x, int y){
	
	rotateY(-x / 5.0f);
	rotateX( y / 5.0f);
		
}


void Camera::rotateCamera(float AngleDir, float xSpeed, float ySpeed, float zSpeed){
	
	// TODO - though we probably dont need the degrees of freedom this allows
	
	
	
}

