// simple camera class using euler angles for now
#ifndef CAMERA_H_
#define CAMERA_H_

#include "math.h"

#include "SDL_opengl.h"	//for some 3D transforms - lazy and we dont have a matrix class :D
#include "vector.h"

// another definition of PI
const float PI = 3.1415926535897932384626f;
const float PIby180 = PI/(float)180;

class Camera
{
public:
	
	typedef physics::Vector2D Vector2D;
	typedef physics::Vector3D Vector3D;

	Camera();
	virtual ~Camera();
	
	Vector3D position;
	Vector3D viewDir;
	
	Vector3D upDir;
	Vector3D rightDir;
	
	
	float xRotation,yRotation,zRotation;
	float currentRotationAngle;
	
	
	bool cameraMoved;
	bool viewDirChanged;
	
	void setCamera(Vector3D pos, Vector3D view, Vector3D up);
	
	void rotateX(float angle);
	void rotateY(float angle);
	void rotateZ(float angle);
	
		
	void moveforwardCamera(float step);
	void strafeCamera(float step);
	
	void rotateByMouse(int x, int y, int midX, int midY);
	void rotateCamera(float AngleDir, float xSpeed, float ySpeed, float zSpeed);
	void testMouse(int x, int y);
	
	// aka stick the transform on the stack
	void render();
	
	
};



#endif 
