#ifndef _CAMERA_
#define _CAMERA_

#include "vector.h"

class Camera {
	public:
	
	Camera () {}
	virtual ~Camera () {}
	
	virtual physics::Vector3D screen2world (int x, int y) const = 0;

	virtual void zoomIn (int x, int y) = 0;
	virtual void zoomOut (int x, int y) = 0;
	
	virtual void translate (const physics::Vector3D& t) = 0;
	
	virtual void update () = 0;
	virtual void use () = 0;
	
	virtual bool isVisible (physics::Body2D* body) const = 0;
	virtual bool isVisible (physics::Body3D* body) const = 0;
	
	virtual bool is2D() const = 0;
	virtual bool is3D() const = 0;
};

#endif

