#ifndef _CAMERA_2D_
#define _CAMERA_2D_

#include "camera.h"
#include "window.h"

class Camera3D;

// Man, I sure am writing great code today...
static const float MAGIC_CONVERSION_CONSTANT = 800.0f;

class Camera2D : public Camera {
	public:
	
	Camera2D(const physics::Vector2D& centre, float scale)
		: centre(centre), scale(scale), targetScale(scale) {}
	
	Camera2D(float x, float y, float scale)
		: centre(physics::Vector2D(x, y)), scale(scale), targetScale(scale) {}
	
	physics::Vector3D screen2world (int x, int y) const;

	void zoomIn (int x, int y);
	void zoomOut (int x, int y);
	
	void translate (const physics::Vector3D& t);
	
	void copyState (const Camera3D* c);
	
	void update ();
	void use ();
	
	bool isVisible (physics::Body2D* body) const;
	bool isVisible (physics::Body3D* body) const { return true; }
	
	bool is2D() const { return true; }
	bool is3D() const { return false; }

	private:
	
	friend class Camera3D;
	
	physics::Vector2D centre;
	physics::Vector2D mouse;
	float scale;
	float targetScale;
	
	physics::Vector2D minWorld;
	physics::Vector2D maxWorld;
};

inline void Camera2D::zoomIn (int screenX, int screenY) {
	targetScale *= 1.2f;
	mouse = screen2world(screenX, screenY);
}

inline void Camera2D::zoomOut (int screenX, int screenY) {
	targetScale /= 1.2f;
	mouse = screen2world(screenX, screenY);
}

inline void Camera2D::translate (const physics::Vector3D& t) {
	centre += t / 2;
}

#endif

