#ifndef _DIRECTOR_
#define _DIRECTOR_

#include <map>

#include "event.h"
#include "world.h"
#include "vector.h"


class Director {
	public:
		Director (physics::World2D*);
		Director (physics::World2D*, int script);
				
		bool step();
		
		void startMeteorShower();
		void stopMeteorShower();
		void toggleMeteorShower();
		
		void addMeteor(physics::Vector2D);
		
		void startRain();
		void stopRain();		
		void toggleRain();
		
		void startFireworks();
		void stopFireworks();
		void toggleFireworks();
		
		void addExplosion(physics::Vector2D);

		void setActiveDirectorScene(int);
		int getActiveDirectorScene();
				
	private:
		physics::World2D * world;
		long stepsElapsed;
		
		void getScript(int, std::map<long, Event> *);
		std::map<long, Event> eventQueue;
		
		bool meteorShower;
		bool rain;
		bool fireworks;
		int activeDirectorScene;
};

#endif

