#include "display_object.h"
#include "body.h"
using namespace physics;

const Vector3D DisplayObject::staticColour = Vector3D(0.65f, 0.8f, 0.5f);
const Vector3D DisplayObject::sleepColour = Vector3D(0.5f, 0.5f, 0.5f);
const Vector3D DisplayObject::selectionColour = Vector3D(0.2f, 0.5f, 0.7f);

DisplayObject* DisplayObject::getDisplayObject(physics::Body2D* b) {
	if (! b->data) {
		b->data = new DisplayObject(b);
	}
	
	return static_cast<DisplayObject*>(b->data);
}
physics::Vector3D DisplayObject::getNormalColour() {
	return this->colour;
}

physics::Vector3D DisplayObject::getColour() {
	if (isSelected()) {
		return selectionColour;
	} else if (body->isStatic()) {
		return staticColour;
	} else if (! body->isAwake()) {
		return sleepColour;
	} else {
		return this->colour;
	}
}

void DisplayObject::setColour(physics::Vector3D* c) {
	colour = *c;
}

bool DisplayObject::isSelected() {
	return selected;
}

void DisplayObject::setSelected(bool selected) {
	this->selected = selected;
}

int DisplayObject::getBodyID() {
	return bodyID;
}

void DisplayObject::setBodyID(int bodyID) {
	this->bodyID = bodyID;
}