#ifndef _DISPLAY_OBJECT_
#define _DISPLAY_OBJECT_

#include "physics.h"
#include "body.h"
#include "vector.h"
#include "random.h"

using namespace physics;

class DisplayObject {
	public:
	
		static const Vector3D staticColour;
		static const Vector3D sleepColour;
		static const Vector3D selectionColour;

		//Constructor
		DisplayObject(physics::Body2D* targetBody) {
			body = targetBody;
			colour = random_colour();
			selected = false;
		}

		//Static methods
		static DisplayObject* getDisplayObject(Body2D* b);
		
		//Methods
		void setColour(physics::Vector3D* c);
		physics::Vector3D getColour();
		physics::Vector3D getNormalColour(); //Ignores static/selected/sleeping etc
		bool isSelected();
		void setSelected(bool selected);
		int getBodyID(); //Set on world save. Used for joint saving. 
		void setBodyID(int id);


	private:
		//Member data
		physics::Body2D* body;
		physics::Vector3D colour;
		bool selected;
		int bodyID;
};
#endif
