#ifndef _EVENT_
#define _EVENT_

#include "world.h"
#include "vector.h"


class Event {
	public:
		Event() {}
		Event(int newType) {type = newType;}
		Event(int newType, physics::Vector2D newLocation) 
		{
			type = newType;
			location = newLocation;
			size = 1.0;
			velocity = physics::Vector2D(0, 0);
		}
		Event(int newType, physics::Vector2D newLocation, float newSize, physics::Vector2D newVelocity) 
		{
			type = newType;
			location = newLocation;
			size = newSize;
			velocity = newVelocity;
		}
		
		int getType() {return type;}
		float getSize() {return size;}
		physics::Vector2D getLocation() {return location;}
		physics::Vector2D getVelocity() {return velocity;}
		
	private:
		int type;
		physics::Vector2D location;
		float size;
		physics::Vector2D velocity;
};

#endif

