#ifndef _WGD_FRUSTUM_
#define _WGD_FRUSTUM_

#include "vector.h"

/**
 *	View frustum used for culling
 */
class Frustum {
	public:
	
	void init (physics::Vector3D& p, physics::Vector3D& up, physics::Vector3D& forward, physics::Vector3D& left, float fovy, float aspect);
	
	bool inside (const physics::Vector3D& point, float r = 0) const;
	
	bool inside (const physics::Body2D* body) const;
	bool inside (const physics::Body3D* body) const;
	
	private:
	
	// A frustum here has 5 planes: { top, bottom, right, left, near }
	// Technically it should also have far, but I'm lazy.
	struct Plane {
		physics::Vector3D normal;
		float d;
	} plane[5];
	
	// point (or circle) inside a plane
	bool inside (const Plane& plane, const physics::Vector3D& point, float r = 0) const;
};

#endif
