#include "input.h"

#include "window.h"
#include "camera2d.h"
#include "sandbox2d.h"
#include "physics.h"
#include "random.h"

#include <boost/foreach.hpp>

using namespace physics;

Uint8* Input::keystate = 0;
Controller* Controller::active = 0;

void Input::checkEvents () {
	SDL_Event event;

	while (SDL_PollEvent(&event)) {
		switch (event.type) {
			case SDL_KEYDOWN:
				Controller::active->keyDown(event);
			break;
			case SDL_KEYUP:
				Controller::active->keyUp(event);
			break;
			case SDL_MOUSEBUTTONDOWN:
				Controller::active->mouseDown(event);
			break;
			case SDL_MOUSEBUTTONUP:
				Controller::active->mouseUp(event);
			break;
			case SDL_VIDEORESIZE:
				Window::resize(event.resize.w, event.resize.h);
			break;
			case SDL_QUIT:
				exit(0);
			break;
		}
	}
	
	keystate = SDL_GetKeyState(NULL);
}
