#ifndef _RANDOM_
#define _RANDOM_

#include <stdlib.h>

// All the random things in here seem to be deterministically random.
// But that's actually quite nice...

/** Generate a random number from 0.0 to 1.0 */
inline float random_f() {
	return (rand() % 10000) / 10000.0f;
};

/** Generate a random number between 0.0 and n-1. */
inline int random_i(int n) {
	return (rand() % n);
};

/** Generate a random number between min and max-1 */
inline int random_i(int min, int max) {
	return (min + (rand() % (max-min)));
};

/** Generate a random number between min and max-1 */
inline float random_f(float min, float max) {
	return (min + (random_f() * (max-min)));
};

#include "vector.h"

/** Generate a random colour */
inline physics::Vector3D random_colour () {
	//Use void data attribute of body to store an 
	//RGB colour triplet in form of a 3D vector
	//Used in glColor3f(x,y,z)
	physics::Vector3D c;
	c.x = random_f();
	c.y = random_f();
	c.z = random_f();
	return c;
}

/** Generate a random rotation */
inline physics::Vector3D random_rotation () {
	return random_colour();
}


#endif

