#ifndef _SANDBOX_3D_
#define _SANDBOX_3D_

#include "input.h"
#include "common.h"
#include "vector.h"

class Camera3D;

class Sandbox3D : public Controller {
	public:
	
	Sandbox3D ();
	virtual ~Sandbox3D () {}
	
	virtual void update ();
	virtual void draw () const;
	
	virtual void keyDown (SDL_Event& event);
	virtual void keyUp (SDL_Event& event);
	virtual void mouseDown (SDL_Event& event);
	virtual void mouseUp (SDL_Event& event);

	void reset();
	void togglePause();
	void loadPreset (int i);
	// Member data
	private:

	physics::World3D* world;

	physics::Vector3D mouse;
	
	bool dragging;
	bool paused;
	physics::Vector3D clickPos;

	int activeScene;
	
	Camera3D* camera;
	
	physics::Body3D* dragObject;
	physics::Vector3D dragOffset;
	float dragDistance;
	
	physics::Body3D* cameraBody;
};

#endif
