#ifndef _GRAPHICS_
#define _GRAPHICS_

#include "SDL.h"
#include "SDL_opengl.h"

#ifdef USE_FTGL
#include <FTGL/ftgl.h>
#else
class FTFont;
#endif

struct SDL_Surface;

class Window {
	public:
	
	static bool init (const int w = 800, const int h = 600, const char* title = 0, bool resizable = false);
	
	static int width () { return s_width; }
	static void setWidth (const int w);
	
	static int height () { return s_height; }
	static void setHeight (const int h);
	
	static void resize (const int width, const int height);
	
	static bool isResizable () { return s_resizable; }
	
	static bool isFullscreen () { return s_fullscreen; }
	static void setFullscreen (bool b);
	static void toggleFullscreen ();
	
	static void beginDraw ();
	static void endDraw ();
	
	// initial Text support methods
	static void drawText(const char* text);
	static bool setTitle (const char* title);
	static SDL_Surface* getSurface () { return s_screen; }
	
	private:
	
	static bool reset ();
	
	static bool s_ready;
	
	static int s_width;
	static int s_height;
	
	static int s_fullscreen_width;
	static int s_fullscreen_height;
	
	static int s_old_width;
	static int s_old_height;
	
	static bool s_resizable;
	static bool s_fullscreen;
	
	static FTFont* guiFont;

	static SDL_Surface* s_screen;
};

#endif

