#ifndef _WORLD_FACTORY_
#define _WORLD_FACTORY_

#include "world.h"

class WorldFactory {
	public:
	
	static void createPyramid (physics::World2D* w, const physics::Vector2D& p, float size, int layers, float hgap = 0.1f, float vgap = 0.1f);
	static void createChipmunkDemo (physics::World2D* w, const physics::Vector2D& p, int layers);
	
	static physics::World2D* load2D (int i);
	static physics::World3D* load3D (int i);

	static physics::World2D* init2D ();
	static physics::World3D* init3D ();
	
	static physics::World2D* load2D_0 ();
	static physics::World2D* load2D_1 ();
	static physics::World2D* load2D_2 ();
	static physics::World2D* load2D_3_stupid ();
	static physics::World2D* load2D_3 ();
	static physics::World2D* load2D_4_stupid ();
	static physics::World2D* load2D_4 ();
	static physics::World2D* load2D_5 ();
	static physics::World2D* load2D_6 ();
	static physics::World2D* load2D_7 ();
	static physics::World2D* load2D_8 ();
	static physics::World2D* load2D_9 ();
	static physics::World2D* load2D_10 ();
	static physics::World2D* load2D_11 ();
	static physics::World2D* load2D_12 ();
	static physics::World2D* load2D_13 ();
	static physics::World2D* load2D_14 ();
	static physics::World2D* load2D_15 ();
	static physics::World2D* load2D_16 ();
	static physics::World2D* load2D_17 ();
	static physics::World2D* load2D_18 ();
};

#endif

